import pandas as pd


def single_brinson(portfolio, index_component, industry, stk_rtns):
    total_df = pd.merge(industry[["security_code", "industry_name"]], portfolio[["security_code", "weight"]],
                        on=["security_code"], how="left").fillna(0.0)
    total_df = pd.merge(total_df, index_component[["security_code", "weight"]], on=["security_code"], how="left").fillna(0.0)
    total_df = pd.merge(total_df, stk_rtns[["security_code", "chg_pct"]], on=["security_code"], how="inner")
    total_df.columns = ["security_code", "industry", "portfolio", "benchmark", "chg_pct"]
    total_df["p_ret"] = total_df["portfolio"] * total_df["chg_pct"]
    total_df["b_ret"] = total_df["benchmark"] * total_df["chg_pct"]
    total_df = total_df.groupby("industry")[["portfolio", "benchmark", "p_ret", "b_ret"]].agg("sum")
    total_df["p_ret"] = total_df["p_ret"] / (total_df["portfolio"] + 1e-16)
    total_df["b_ret"] = total_df["b_ret"] / (total_df["benchmark"] + 1e-16)

    total_df["TR"] = total_df["p_ret"] * total_df["portfolio"] - total_df["b_ret"] * total_df["benchmark"]
    total_df["SR"] = (total_df["p_ret"] - total_df["b_ret"]) * total_df["benchmark"]
    total_df["AR"] = total_df["b_ret"] * (total_df["portfolio"] - total_df["benchmark"])
    total_df["IR"] = (total_df["p_ret"] - total_df["b_ret"]) * (total_df["portfolio"] - total_df["benchmark"])
    return total_df
